---
title: ':where()'
slug: 'Web/CSS/:where'
tags:
  - ':where'
  - CSS
  - Experimental
  - NeedsBrowserCompatibility
  - NeedsContent
  - NeedsExample
  - Pseudo-class
  - Reference
  - Selector
  - Selectors
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:where()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> function takes a selector list as its argument, and selects any element that can be selected by one of the selectors in that list.</p>

<pre class="brush: css notranslate"><code>/* Selects any paragraph inside a header, main
   or footer element that is being hovered */
:where(header, main, footer) p:hover {
  color: red;
  cursor: pointer;
}

/* The above is equivalent to the following */
header p:hover,
main p:hover,
footer p:hover {
  color: red;
  cursor: pointer;
}</code></pre>

<p>The difference between <code>:where()</code> and {{CSSxRef(":is", ":is()")}} is that <code>:where()</code> always has 0 <a href="/en-US/docs/Web/CSS/Specificity">specificity</a>, whereas <code>:is()</code> takes on the specificity of the most specific selector in its arguments.</p>

<h3 id="Forgiving_Selector_Parsing">Forgiving Selector Parsing</h3>

<p>The specification defines <code>:is()</code> and <code>:where()</code> as accepting a <a href="https://drafts.csswg.org/selectors-4/#typedef-forgiving-selector-list">forgiving selector list</a>.</p>

<p>In CSS when using a selector list, if any of the selectors are invalid then the whole list is deemed invalid. When using <code>:is()</code> or <code>:where() </code>instead of the whole list of selectors being deemed invalid if one fails to parse, the incorrect or unsupported selector will be ignored and the others used.</p>

<pre class="brush: css notranslate">:where(:valid, :unsupported) {
  ...
}</pre>

<p>Will still parse correctly and match <code>:valid</code> even in browsers which don't support <code>:unsupported</code>, whereas:</p>

<pre class="brush: css notranslate">:valid, :unsupported {
  ...
}</pre>

<p>Will be ignored in browsers which don't support <code>:unsupported</code> even if they support <code>:valid</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Comparing_where_and_is">Comparing :where() and :is()</h3>

<p>This example shows how <code>:where()</code> works, and also illustrates the difference between <code>:where()</code> and <code>:is()</code>.</p>

<p>Take the following HTML:</p>

<pre class="brush: html notranslate">&lt;article&gt;
  &lt;h2&gt;:is()-styled links&lt;/h2&gt;
  &lt;section class="is-styling"&gt;
    &lt;p&gt;Here is my main content. This &lt;a href="https://mozilla.org"&gt;contains a link&lt;/a&gt;.
  &lt;/section&gt;

  &lt;aside class="is-styling"&gt;
    &lt;p&gt;Here is my aside content. This &lt;a href="https://developer.mozilla.org"&gt;also contains a link&lt;/a&gt;.
  &lt;/aside&gt;

  &lt;footer class="is-styling"&gt;
    &lt;p&gt;This is my footer, also containing &lt;a href="https://github.com/mdn"&gt;a link&lt;/a&gt;.
  &lt;/footer&gt;
&lt;/article&gt;

&lt;article&gt;
  &lt;h2&gt;:where()-styled links&lt;/h2&gt;
  &lt;section class="where-styling"&gt;
    &lt;p&gt;Here is my main content. This &lt;a href="https://mozilla.org"&gt;contains a link&lt;/a&gt;.
  &lt;/section&gt;

  &lt;aside class="where-styling"&gt;
    &lt;p&gt;Here is my aside content. This &lt;a href="https://developer.mozilla.org"&gt;also contains a link&lt;/a&gt;.
  &lt;/aside&gt;

  &lt;footer class="where-styling"&gt;
    &lt;p&gt;This is my footer, also containing &lt;a href="https://github.com/mdn"&gt;a link&lt;/a&gt;.
  &lt;/footer&gt;
&lt;/article&gt;</pre>

<p>In this somewhat-contrived example, we have two articles that each contain a section, an aside, and a footer. They differ by the classes used to mark the child elements.</p>

<p>To make selecting the links inside them simpler, but still distinct, we <em>could</em> use <code>:is()</code> or <code>:where()</code>, in the following manner:</p>

<pre class="brush: css notranslate">html {
  font-family: sans-serif;
  font-size: 150%;
}

:is(section.is-styling, aside.is-styling, footer.is-styling) a {
  color: red;
}

:where(section.where-styling, aside.where-styling, footer.where-styling) a {
  color: orange;
}</pre>

<p>However, what if we later want to override the color of links in the footers using a simple selector?</p>

<pre class="brush: css notranslate">footer a {
  color: blue;
}</pre>

<p>This won't work for the red links, because the selectors inside <code>:is()</code> count towards the specificity of the overall selector, and class selectors have a higher specificity than element selectors.</p>

<p>However, selectors inside <code>:where()</code> have specificity 0, so the orange footer link will be overidden by our simple selector.</p>

<p><strong>Note</strong>: You can also find this example on GitHub; see <a href="https://mdn.github.io/css-examples/is-where/">is-where</a>.</p>

<p>{{EmbedLiveSample('Examples', '100%', 600)}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Selectors", "#zero-matches", ":where()")}}</td>
   <td>{{Spec2("CSS4 Selectors")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.selectors.where")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef(":is", ":is()")}}</li>
 <li><a href="/en-US/docs/Web/CSS/Selector_list">Selector list</a></li>
 <li><a href="/en-US/docs/Web/Web_Components">Web components</a></li>
</ul>
